#include <sys/socket.h>

extern unsigned char buf[1024]; /* should be more than DNS_MAXPACKET */

void log(int level, const char *fmt, ...);

struct zonedata;

typedef struct zonedata *z_loadfn(const char *name);
typedef void z_freefn(struct zonedata *zone);

typedef unsigned
z_queryfn(const struct zonedata *const zone,
	  unsigned char *const p, unsigned char *t,
	  const unsigned char *const query,
	  unsigned qflg);

#define QUERY_A   0x01
#define QUERY_TXT 0x02

/* see details of DNS packet structure in rbldnsd.c */

#define refuse(packet,cptr,code) \
  packet[2] = 0x84, packet[3] = (code), (cptr - packet)

#define nxdomain(packet,cptr) \
  packet[2] = 0x84, packet[3] = 3, (cptr - packet)

unsigned char *
addrec_a(unsigned char *const p, unsigned char *t, in_addr_t aip);

unsigned char *
addrec_txt(unsigned char *const p, unsigned char *t, const char *txt,
	   in_addr_t qip);

int dn4octet(const unsigned char *q, in_addr_t *addrp);

void *emalloc(const char *zone, unsigned size);
void *erealloc(const char *zone, void *ptr, unsigned size);
char *estrdup(const char *zone, const char *str);

/* list of zone types */
#define definezonetype(t) \
 z_queryfn t##_query; z_loadfn t##_load; z_freefn t##_free
definezonetype(simple);
#undef definezonetype
